<?php
/**
 * @package Plugin AudioEye for Joomla! 3.0
 * @version 1.0
 * @author AudioEye
 * @copyright (C) 2020- AudioEye
 * @license GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
**/
// no direct access
defined( '_JEXEC' ) or die;

class plgSystemAudioEye extends JPlugin
{
	/**
	 * Load the language file on instantiation. Note this is only available in Joomla 3.1 and higher.
	 * If you want to support 3.0 series you must override the constructor
	 *
	 * @var    boolean
	 * @since  3.1
	 */
	protected $autoloadLanguage = true;

	/**
	 * Plugin method with the same name as the event will be called automatically.
	 */
    public function onBeforeCompileHead()
	 {
		/*
		 * Plugin code goes here.
		 * You can access database and application objects and parameters via $this->db,
		 * $this->app and $this->params respectively
		 */

        $app = JFactory::getApplication();

        // only insert the script in the frontend
        if ($app->isClient('site')) {

			// Get a db connection.
			$db = JFactory::getDbo();
			$query = $db->getQuery(true);
			$query->select($db->quoteName(array('app_id')));
			$query->from($db->quoteName('#__audioeye'));
			$db->setQuery($query);
			$results = $db->loadObjectList();

			$appId = $results[0]->app_id; // get app id

			$document = JFactory::getDocument();
			$document->addScript('https://wsv3cdn.audioeye.com/api/entryPoint.php?h='. $appId .'&ct=js');

          }
          
      }
}

?>
